//========================================================
// Benchmark "spherical scalar waves generated by an initial pulse"
// File: GetDP simulation
//========================================================

Include "gaussInCuboid.dat";

Group {
  GammaD = Region[{}];
  GammaN = Region[{}];
  GammaR = Region[{BOUNDARY}];
  Omega = Region[{DOMAIN}];
}

Function {
  InitValue[] = Exp[-(X[]^2+Y[]^2+Z[]^2)/(r*r)];
}

Constraint {
  { Name pConstraint;
    Case {
      { Region Omega; Type Init; Value InitValue[]; }
    }
  }
  { Name uConstraint;
    Case {
      { Region GammaD; Type Assign; Value 0.; }
      { Region Omega; Type Init; Value 0.; }
    }
  }
}

Include "formulations_scalarWaves.pro";

DefineConstant[
  C_ = {"-solve -pos -v2", Name "GetDP/9ComputeCommand", Visible 0},
  R_ = {"WaveEqn_Reso", Name "GetDP/1ResolutionChoices", Visible 1,
        Choices {"WaveEqn_Reso", "MembraneSys_Reso", "EulerSys_Reso"}},
  P_ = {"WaveEqn_PostOp", Name "GetDP/2PostOperationChoices", Visible 1,
        Choices {"WaveEqn_PostOp", "MembraneSys_PostOp", "EulerSys_PostOp"}}
];
